
// 2knob + 1switch + Expression->USB converter
// Based on example of KUASSA (WF3607_ExpressionPedal) / search original there: https://www.kuassa.com/diy-tutorial-how-to-build-arduino-based-expression-pedal-for-efektor-wf3607/
// Addtition of 2 knobs by Mike Smirnov, Turn2on
// Change it for your needs! A012345.. Analog inputs part for potentiometers, expression pedal inpur, Digital part for switchers, buttons..


#include "MIDIUSB.h"
// Expression pedal pin
#define expPin A0
// Knob-1 pin
#define expPin2 A1
// Knob-2 pin
#define expPin3 A2
// Switch 3PDT pin
#define switchPin 9

int sensorValue = 0;
int sensorValue2 = 0;
int sensorValue3 = 0;
int lastVal = 0;
int lastVal2 = 0;
int lastVal3 = 0;
int tempAnalog = 0;
int tempAnalog2 = 0;
int tempAnalog3 = 0;
int switchVal = HIGH;

void setup() {
  Serial.begin(300);  
  pinMode(switchPin, INPUT);
}

void controlChange(byte channel, byte control, byte value) {
   midiEventPacket_t event = {0x0B, 0xB0 | channel, control, value};
  MidiUSB.sendMIDI(event);
}

void loop() {
  // Reinit Analog Value
  sensorValue = 0;
    sensorValue2 = 0;
        sensorValue3 = 0;

  // Read analog value
  tempAnalog = analogRead(expPin);
    tempAnalog2 = analogRead(expPin2);
        tempAnalog3 = analogRead(expPin3);
  
  // Convert 10 bit to 7 bit
  tempAnalog = map(tempAnalog, 0, 1023, 0, 127);
  tempAnalog = constrain(tempAnalog, 0, 127);

    tempAnalog2 = map(tempAnalog2, 0, 1023, 0, 127);
  tempAnalog2 = constrain(tempAnalog2, 0, 127);

      tempAnalog3 = map(tempAnalog3, 0, 1023, 0, 127);
  tempAnalog3 = constrain(tempAnalog3, 0, 127);

  // Read digital input (Switch)
  int readSwitch = digitalRead(switchPin);
  // Send switch status
  if(switchVal != readSwitch){
    switchVal =  readSwitch;
    // Off (0 - 63), On (64 - 127)
    // CC 80   (Our default value for switch 3PDT is using 
    //          MIDI control change number 80
    //          Change this to change control the change number)
    if(switchVal == HIGH){
      controlChange(1, 80, 127);
    }
    else{
      controlChange(1, 80, 0);
    }
    MidiUSB.flush();
  }

  // Send pedal status
  if(tempAnalog != lastVal)
  {
    // CC 11   (Our default value for expression pedal is using 
    //          MIDI control change number 11
    //          Change this to change control the change number)
    controlChange(1, 11, tempAnalog);
    // !Important, Flush after send
    MidiUSB.flush();
  }

    if(tempAnalog2 != lastVal2)
  {
    // CC 12   (Value for Knob-2 is using 
    //          MIDI control change number 12
    //          Change this to change control the change number)
    controlChange(1, 12, tempAnalog2);
    // !Important, Flush after send
    MidiUSB.flush();
  }

     if(tempAnalog3 != lastVal3)
  {
    // CC 13   (Value for Knob-3 is using 
    //          MIDI control change number 13
    //          Change this to change control the change number)
    controlChange(1, 13, tempAnalog3);
    // !Important, Flush after send
    MidiUSB.flush();
  }

  // Store current value to be used laters
  lastVal = tempAnalog;
    lastVal2 = tempAnalog2;
        lastVal3 = tempAnalog3;
  delay(5);  
}
